;pcr12_97.asm
;*****************
;Procedura umoznuje vypis cisel v nasle-
;dovnych ciselnych sustavach 2,8,10,16.
;Vstup: register AX = cislo
; register BX = zaklad sustavy
;Vystup: cez INT 21h na obrazovku.
;-----------------------------------------------
transfer1	 proc near
 	push ax
 	xor cx, cx
wn0:	xor dx, dx
 	div bx
 	push dx
 	inc cx
 	test ax, ax
 	jnz wn0
wn2:	pop dx
 	or dl, '0'
 	cmp dl, '9'
 	jbe wn3
 	add dl, 7
wn3:	mov ah, 2
 	int 21h
 	loop wn2
 	pop ax
 	ret
transfer1	 endp

;------------------------------------------------
;Procedura umoznuje vypis cisel v nasle-
;dovnych ciselnych sustavach 2,8,10,16.
;Vstup: reg. AX = cislo
; reg. BX = zaklad sustavy
; reg. ES = segment videoram
; reg. DI = offset videoram
; reg. SI = offset color t.j.
;reg. Ukazuje na miesto v pamati kde je
;ulozeny kod farby, ktorou budu cisla
;zafarbene. Pred zavolanim tejto proc.
;musime na tuto adresu ulozit kod farby.
;POZOR!!! Identifikator color a null je
;definovany v ramci procedury. Null
;urcuje ako ma byt cislo zarovnane.
;
;Vystup: Priamy zapis do videoram.
;------------------------------------------------
transfer2	 proc near
 	push ax
 	sub cx,cx
x0:     sub dx,dx
 	div bx
 	push dx
 	inc cx
 	test ax,ax
 	jnz x0
	mov ax,word ptr[si+1]
 	cmp ax,cx
 	jbe x2
 	mov bx,cx
 	sub ax,cx
 	mov cx,ax
 	mov dl,48
x1:	mov es:[di],dl
	mov al,[si+0]
 	mov es:[di+1],al
 	inc di
 	inc di
 	loop x1
 	mov cx,bx
x2:	pop dx
 	or dl,'0'
 	cmp dl,'9'
 	jbe x3
 	add dl,7
x3:	mov es:[di],dl
	mov al,[si+0]
 	mov es:[di+1],al
 	inc di
 	inc di
 	loop x2
 	pop ax
 	ret
color	db ?
null 	dw ?
transfer2	 endp

;------------------------------------------------
;Procedura umoznuje prevod z ASCII na
;cislo v rozsahu max. (0 az 65535).
;Dokaze previest binarne,
;hexadicimalne a decimalne cisla.
;
;Vstup: reg. BX obsahuje offset adresy
;cisla v pamati.
;
;Vystup: reg. DX obsahuje cisel. Hodnotu
;------------------------------------------------
readnum proc near
 	mov al,byte ptr [cs:bx]
 	inc bx
 	mov dx,0
 	mov cl,16
 	xor ch,ch
 	cmp al,"#"
 	jz readnum3
 	mov cl,2
 	xor ch,ch
 	cmp al,"%"
 	jz readnum3
 	xor ch,ch
 	mov cl,10
 	dec bx
readnum3: mov al,byte ptr [cs:bx]
	sub al,"0"
 	cmp al,10
 	jc readnum4
 	sub al,"A"-"9"-1
readnum4: cmp al,16
 	jc readnum6
 	sub al,32
readnum6: cmp al,16
 	jnc readnum1
 	inc bx
 	push bx
	mov bx,dx
 	mov dx,0
 	push cx
readnum5: add dx,bx
 	loop readnum5
 	mov bh,ch
 	pop cx
 	mov bl,al
 	add dx,bx
 	pop bx
 	jmp short readnum3
readnum1: ret
readnum endp

;------------------------------------------------
;Procedura efektne zmaze obrazovku.
;
;Vstup: register SI = offset
;vstupnych dat.
;
;Vystup: Efektne vycisti obrazovku.
;------------------------------------------------
efekt	 proc near
    	 mov cx,25
alfa:	 push cx
 	 mov di,offset tabulka
 	 mov cx,8
beta:	 push cx
  	 mov ax,0601h
 	 mov bh,[si+0]
 	 mov dx,[di]
 	 mov cx,[di+2]
 	 int 10h
 	 mov ax,0701h
 	 mov bh,[si+0]
 	 mov dx,[di+4]
 	 mov cx,[di+6]
 	 int 10h
 	 pop cx
 	 add di,8
 	 loop beta
 	 push cx
 	 mov cx,word ptr[si+1]
gama:	 loop gama
 	 pop cx
 	 pop cx
 	 loop alfa
 	 ret
tabulka	 db 4,24,0,0
 	 db 9,24,5,0
 	 db 14,24,10,0
 	 db 19,24,15,0
 	 db 24,24,20,0
 	 db 29,24,25,0
 	 db 34,24,30,0
 	 db 39,24,35,0
 	 db 44,24,40,0
 	 db 49,24,45,0
 	 db 54,24,50,0
 	 db 59,24,55,0
 	 db 64,24,60,0
 	 db 69,24,65,0
 	 db 74,24,70,0
 	 db 79,24,75,0
efekt	 endp

