;-------------------------------------------------------------------------------
; Program: Rezidentne hodiny +                        JAZYK: Assembler
;     + aktualny datum.                         Program typ: COM
;                                                   Version: 1.21
;   Naprogramoval: Peter Gasparovic 
; (c)1996 Copyright UNIVERSAL SYSTEMS             Dokoncene: 21:43/15.02.1997
;-------------------------------------------------------------------------------

      .model tiny               ;Tento model sa pouziva pre subory typu COM.
      
  

      
      .286                      ;Typ procesoru.


CODE SEGMENT public             ;Zaciatok CODE segmentu.
     assume cs:code,ds:code     ;Direktiva definuje zavislost segmentovych
                                ;registrov na segmente alebo skupine (GROUP).
        org 100h                ;Zaciatok .COM suboru.


start1: jmp start               ;Skok na zaciatok programu.

segadr  equ 0b800h               ;Zaciatok VRAM len pre CGA, EGA, VGA.
atribut equ 079h                 ;Farba.
atributnavod equ 7

zaciatok label near             ;Od tohto miesta program zostane v pameti ako
                                ;rezident.



;-------------------------------------------------------------------------------
staryint dw ?                   ;Premenne pouzite v programe.
         dw ?
offadr   dw ?
offadr1  dw ?
offadr2  dw ?
d_on_off db 1
busy     db 0
pat      db 18
citac    db 0
param    db 0
sekcas   db ?
mincas   db ?
hodcas   db ?
cas      db 0,0,':',0,0,':',0,0 ;Retazec casu.
datum    db 0,0,0,0,0,0,0,0,0,0 ;Retazec datumu.
;-------------------------------------------------------------------------------

@filename:

;-------------------------------------------------------------------------------																																							
disp macro adrstr               ;Makro pre vypis textu na obrazovku.
        push cs                 ;Uschovaj CS.
        pop ds                  ;Vyber DS.
        mov dx,offset adrstr    ;Offset na adresu textu vpameti.
        mov ah,09h              ;Sluzba DOSu pre vypis retazca na obrazovku.
        int 21h                 ;Vykonaj.
        endm                    ;Koniec Makra.
;-------------------------------------------------------------------------------



;-------------------------------------------------------------------------------
novyint  proc                   ;Procedura predstavuje rezidentnu cast, ktora
zac:                            ;zostane v pameti a bude na nu presmerovane
                                ;prerusenie 1ch.
         cli                    ;Zakaz prerusenie.
         cmp cs:busy,0          ;Neprerusujem nahodou sam seba?
	 jne old                ;Ano! Tak to nie. Skoc na povodnu obsluhu.
         mov cs:busy,1          ;Nastav priznak aktivacie.
         push es                ;Registre na zasobnik.
         push ds
	 push di
         push si
         push dx
         push cx
	 push bx
	 push ax
         push bp
         pushf
	 push cs
	 pop ds
         mov al,citac           ;Nastav do AL pocet tikov casovaca (18.2).
         cmp al,0               
         jnz pokr               ;Nie je to nula? [Skoc.]
         mov ah,0               ;Vynuluj AH.
         xor dx,dx
         mov al,sekcas          ;Do AL daj pocet sekund.
         mov ch,5               ;CH napln na 5.
         div ch                 ;Vykonaj sekcas mod 5.
         xor al,al              ;Vynuluj register AL.
         cmp ah,0               ;Je vysledok nula?
	 jz pokr1               ;Ano - pokracuj.
	 mov pat,18             ;Nie - nastav 18 tikov za sekundu.
	 jmp short pokr
pokr1:   mov pat,19             ;Nastav 19 tikov za sekundu.
pokr:    mov al,citac
 	 inc al
 	 cmp al,pat
	 jge sekunda            ;Presla sekunda - zobraz novy cas.
	 mov citac,al

ukonci:  mov cs:busy,0          ;Vynuluj priznak aktivacie.
         popf
         pop bp
         pop ax                 ;Vyber registre zo zasobniku.
	 pop bx
	 pop cx
 	 pop dx
	 pop si
	 pop di
         pop ds
         pop es
         sti                       ;Povol prerusenie.
old:     jmp dword ptr cs:staryint ;Skok na stare prerusenie.

sekunda: 
         mov citac,00
         inc sekcas
         mov dl,3               ;Budu sa konvertovat 3 cisla do ASCII.
         cmp sekcas,60          ;Preslo uz 60 sekund?
         jl dalsi
         mov sekcas,00          ;Ano - prave presla jedna minuta.
         inc mincas
         cmp mincas,60          ;Preslo uz 60 minut?
         jl dalsi
         mov mincas,00          ;Ano - prave presla jedna hodina. 
	 inc hodcas
         push ax                ;Uschovaj registre.
         push bx
         push cx
         mov bl,2
         call beep              ;Presla hodina - spusti zvukovy efekt.
         pop cx                 ;Obnov registre.
         pop bx 
         pop ax
	 cmp hodcas,24          ;Preslo uz 24 hodin?
	 jl dalsi 
	 mov hodcas,00          ;Ano - vynuluj hodiny a zacni znova.
         push dx
         mov ax,cs              ;Tato cast sa stara o nastavenie noveho datumu.
	 mov es,ax             
	 mov ax,offset datum
	 mov di,ax
         call datum1
         pop dx

dalsi:
         mov bl,sekcas
opakuj:  
         xor bh,bh              ;Prevod obsahu registru bl na desiatkove
         xor ax,ax              ;cislo v ASCII.
         mov cx,0010h
tu:    
         add bx,bx              ;Cyklus vlastneho prevodu.
         adc al,al
         daa
         loop tu
         mov bx,ax              ;Postupne roztiahnutie BCD tvaru do 2 bytov.
         rol ax,4
         mov al,bl		
         and al,0fh 
         or ax,3030h            ;Prevod BCD na ASCII.
         push ax                ;Uchovanie prevedeneho cisla.
	 dec dl
         jz zobraz
	 mov bl,mincas
         xor bh,bh              ;Prevod obsahu registru bl na desiatkove
                                ;cislo v ASCII.
         xor ax,ax
         mov cx,0010h
tu1:    
         add bx,bx              ;Cyklus vlastneho prevodu.
         adc al,al
         daa
         loop tu1
         mov bx,ax              ;Postupne roztiahnutie BCD tvaru do 2 bytov.
         rol ax,4
         mov al,bl
         and al,0fh 
         or ax,3030h            ;Prevod BCD na ASCII.
         push ax                ;Uschovanie prevedeneho cisla.
         dec dl
 	 jz zobraz
	 mov bl,hodcas          ;Hodiny prevedieme na ASCII.
	 jmp opakuj
zobraz:                         ;Tu budeme cas vypisovat na obrazovku.
         pop dx                 ;Vyber sekundy.
         mov cas,dh
         mov cas[1],dl
         pop dx                 ;Vyber minuty.
         mov cas[3],dh
         mov cas[4],dl
	 pop dx                 ;Vyber hodiny.
         mov cas[6],dh
         mov cas[7],dl
         mov ah,atribut         ;Farba.
         mov bx,segadr          ;Segment adresy vo videoram.
         mov es,bx
         mov bx,offadr          ;Offset adresy vo videoram.
         xor si,si              ;Nastavenie na zaciatok retazca cas.
         xor cas+2,':' XOR ' '  ;Efekt blikania medzi hodinami a minutami
         xor cas+5,':' XOR ' '  ;Efekt blikania medzi minutami a sekundami

d_znak:  
         mov al,cas[si]
         mov word ptr es:[bx],ax
	 inc bx
         inc bx
         inc si
         cmp si,8               ;Je uz cas zobrazeny?
         jl d_znak              ;Nie je - tak pokracuj vo vypise.

         mov al,[d_on_off]      ;Do AL informaciu o datume. 
         cmp al,0               ;Je povolene vypnut datum.
         je off                 ;Ano, je - vypinam.


         mov ah,atribut         ;Farba.
         mov bx,segadr          ;Segment adresy vo videoram.
         mov es,bx
         mov bx,offadr1         ;Offset adresy vo videoram.
;         xor datum+2,'.' XOR ' '  ;Efekt blikania medzi dnom a mesiacom
;         xor datum+5,'.' XOR ' '  ;Efekt blikania medzi mesiacom a rokom
	 xor di,di              ;Nastavenie na zaciatok retazca datum.
d_znak1:
	 mov al,datum[di]
	 mov word ptr es:[bx],ax
	 inc bx
	 inc bx
	 inc di
	 cmp di,10              ;Je uz datum zobrazeny?
	 jl d_znak1             ;Nie je - tak pokracuj vo vypise.
off:     jmp ukonci

novyint  endp                   ;Koniec procedury.
;-------------------------------------------------------------------------------

beep     proc near              ;Kratke pipnutie cez speaker.
         cli
         mov al,10110110b
         out 43h,al
         mov ax,533h
         out 42h,al
         mov al,ah
         out 42h,al
         in  al,61h
         mov ah,al
         or  al,03
         out 61h,al
         sub cx,cx
g7:      loop g7
         dec bl
         jnz g7
         mov al,ah
         out 61h,al
         sti
         ret
beep     endp

datum1   proc near
         push es
         push ds
	 push di
         push si
         push dx
         push cx
	 push bx
	 push ax
         push bp
         pushf
         mov ax,0400h
         mov bx,8Eh
         int 1ah
         mov al,dl
         call bcdkonvert
         stosw
         mov al,'.'
         stosb
         mov al,dh
         call bcdkonvert
         stosw
         mov al,'.'
         stosb
         mov al,ch
         call bcdkonvert
         stosw
         mov al,cl
         call bcdkonvert
         stosw
         popf
         pop bp
         pop ax
	 pop bx
	 pop cx
 	 pop dx
	 pop si
	 pop di
         pop ds
         pop es
         ret
datum1   endp

;-------------------------------------------------------------------------------
bcdkonvert  proc near           ;Procedura konvertuje bcd na ASCII.
            push cx             ;Uschovaj CX.
            mov cl,4
            mov ah,al           ;AH:=Nizsie 4 bity.
            shr al,cl           ;AL:=Vyssie 4 bity.
            and ax,0f0fh
            add ax,'00'
            pop cx              ;Vyber CX.
            ret                 ;Navrat.
bcdkonvert  endp                ;Koniec procedury.
;-------------------------------------------------------------------------------

     


start:                          ;Tu sa program nastartuje pri spusteni.
        xor ax,ax
        mov si,80h              ;Zaciatok prikazoveho riadku.
        cmp byte ptr [si],0     ;Je zadany nejaky znak?
        jne @1                  ;Ano - vyhodnotime to.
        disp msg4               ;Inak vypis Info.
        jmp exit                ;Ukonci program.
@1:	
        mov cl,[si]             ;Dlzka prikazoveho riadku do registru CL.
        xor ch,ch               ;Vynuluj CH.
        inc si                  ;Zaciatok prikazoveho riadku.
        cld
loadp:
        lodsb                   ;Nacitaj do AL.
        cmp al,"/"              ;Je to parameter '/'?
        je findp                ;Ano - tak pokracuj v spracovavani.
        loop loadp              ;Dalsi znak.
        cmp byte ptr param,1
        jne error1              ;Nic som nenasiel - vypis chybu.
        jmp instal	
help:
        jmp help1               ;Zobraz help.
instal: 
        jmp instal1             ;Nainstaluj program do pameti.
findp: 
        mov byte ptr param,1
        cmp byte ptr [si],"?"   ;Je to napoveda?
        je help                 ;Ano - zobraz ju.


        and byte ptr [si],0dfh  ;Konverzia na velke pismena.
        cmp byte ptr [si],"O"   ;Odinstalovat z pameti?
        je driver               ;Ano - odinstaluj.
        cmp byte ptr [si],"H"   ;Je to help?
        je help                 ;Ano - zobraz ho.
        cmp byte ptr [si],"I"   ;Instalovat program?
        je instal               ;Ano - instaluj.
        cmp byte ptr [si],"D"   ;Instalovat program?
        je dateup               ;Ano - instaluj.
error1: disp msg0               ;Nenasiel som ani jeden z povolenich parametrov.
        jmp exit	        ;Vypisem teda chybu.

dateup: jmp dateup1             ;Skok na dateup1.

error:
        mov ax,cs               ;CODE Segment do AX.
        mov ds,ax               ;A teraz aj do DS.
        mov ah,09h              ;Sluzba DOSu na vypis retazca.
        int 21h  
        mov ax,4c01h            ;Navrat do DOSu s chybovym stavom cislo 1.
        int 21h
driver: 
        call je_tam             ;Hladanie kopie programu v pameti.
        jc @2                   ;Program najdeni - pokracujem v spracovavani.
        mov dx,offset msg1      ;Nenasiel som - vypis chybu.
        jmp error
@2:
        mov word ptr es:[@filename],0dedh ;Zmenim kopiu, aby sa uz nenasla.
        push es                 ;Register ES adresuje rezidentnu kopiu v pameti.
        pop ds                  ;A teraz aj DS.
        xor ax,ax
        mov es,ax               ;ES nastavime na tabulku preruseni INT.
        mov ax,ds               ;Porovnam segment rezidentnej
        cmp ax,es:[1ch*4+2]     ;kopie s vektorom INT 1Ch.
        mov dx,offset msg2      ;Nie je mozne uvolnit pamet ked vektor
        jne error               ;smeruje inam.
        push ds                 ;DS adresuje rezidentnu kopiu.
        pop es                  ;A teraz tiez ES.
        mov ax,251ch            ;Vratim povodny INT 1ch.
        mov dx,es:[staryint]
        mov ds,es:[staryint+2]
        int 21h
        push es
        mov ah,49h              ;Uvolnime pamet rezidentneho programu.
        int 21h
        push cs                 ;Do DS adresu sprav.
        pop ds
        disp msg3               ;Program je uvolneni z pameti.
        mov ax,4c00h            ;Navrat do DOSu.
        int 21h                 ;Chybova uroven 0. 

datedown:
        call je_tam             ;Hladanie kopie programu v pameti.
        jc @3                   ;Program najdeni - pokracujem v spracovavani.
        mov dx,offset msg1      ;Nenasiel som - vypis chybu.
        jmp error
@3:
        mov es:[d_on_off],1     ;Zrus vypis datumu.
        mov ax,4c00h            ;Navrat do DOSu.
        int 21h                 ;Chybova uroven 0. 

dateup1: cmp byte ptr [si+1],"+"   ;Mam zobrazit datum?
        je datedown             ;Ano - zobraz ho.

        cmp byte ptr [si+1],"-"   ;Mam vypnut datum?
        je dateup2               ;Ano - vypni ho.
        jmp error1

dateup2: call je_tam             ;Hladanie kopie programu v pameti.
        jc @4                   ;Program najdeni - pokracujem v spracovavani.
        mov dx,offset msg1      ;Nenasiel som - vypis chybu.
        jmp error
@4:
        mov es:[d_on_off],0     ;Povolenie vypisovat datum. 
        mov ax,offset datum
        mov di,ax
        call datum1
        mov ax,4c00h            ;Navrat do DOSu.
        int 21h                 ;Chybova uroven 0. 


;-------------------------------------------------------------------------------
je_tam  proc near               ;Procedura hlada kopiu programu v pameti a ak
                                ;ju najde, nastavi priznak CF a register ES
                                ;ukazuje na segment kopie.
        mov bx,600h             ;Tu zacnem porovnavat. 600h
        mov ax,cs               ;Tu skoncim.
        cld
j4:
        inc bx                  ;Dalsi paragraf.
        cmp ax,bx               ;Je koniec?
        mov es,bx               ;Nastavim porovnavani segment.
        je end_s
        mov si,offset @filename ;Porovnavam zaciatok.
        mov di,si               ;O dlzke 16 bajtov.
        mov cx,16
        rep cmpsb
        or cx,cx                ;Bolo to rovnake?
        jnz j4                  ;Nie - tak pokracuj v hladani.
        stc                     ;Nasiel som kopiu - nastavim CF.
        ret                     ;Navrat.
end_s:  
                                ;Hladam v HMA (Upper Memory Block - UMB).
        mov bx,0c800h           ;Tu zacnem porovnavat.
        mov ax,0f700h           ;Tu skoncim.
        cld
j5:
        inc bx                  ;Dalsi paragraf.
        cmp ax,bx               ;Je koniec?
        mov es,bx               ;Nastavim pozadovany segment.
        je end_hled
        mov si,offset @filename ;Porovnam zaciatok.
        mov di,si               ;O dlzke 16 bajtov.
        mov cx,16
        rep cmpsb
        or cx,cx                ;Bolo to rovnake?
        jnz j5                  ;Nie - pokracuj v hladani.
        mov dx,cs
        cmp bx,dx
        je end_hled
        stc                     ;Nasiel som kopiu - nastavim CF.
        ret                     ;Navrat.
end_hled:
        clc                     ;Nic som nenasiel - zrusim CF.
        ret                     ;Navrat.
je_tam  endp                    ;Koniec procedury.
;-------------------------------------------------------------------------------

chyba:  disp msg5               ;Vypis chybove hlasenie.
        jmp exit                ;Navrat do DOSu.


instal1:                        ;Instalacna cast.
        call je_tam             ;Zisti ci uz je program v pameti.
        jc chyba                ;Ano - vypis chybu.
        mov ax,cs               ;Nie je - pokracuj instalaciou.
        mov ds,ax               ;Nastav DS
        mov ah,2ch              ;Sluzba DOSu na nacitanie casu.
	int 21h


        sub dh,1                ;Spomal cas.


        mov byte ptr [sekcas],dh
        mov byte ptr [mincas],cl
        mov byte ptr [hodcas],ch
        mov ax,cs
        mov es,ax               ;CS do ES.
        mov ax,offset datum     ;Offset na buffer (datum).
        mov di,ax
        call datum1             ;Nastav aktualny datum z CMOS.

        mov dx,offset zprava    ;Vypis info o instalacii.
        mov ah,09h              ;Sluzba DOSu na vypis retazca.
        int 21h
bezpar:   
        mov ax,0                ;Vypocet adresy vo videoram (riadok).
        mov bx,71               ;Stlpec.
        mov dl,80
        mul dl
        add ax,bx
        mov dx,2
        mul dx  
        mov word ptr [offadr],ax
        mov ax,1                ;Vypocet adresy vo videoram (riadok).
        mov bx,70               ;Stlpec.
        mov dl,80
        mul dl
        add ax,bx
        mov dx,2
        mul dx
        push cs
        pop ds
        mov word ptr [offadr1],ax
        
        mov ax,351ch           ;Sluzba DOSu pre zistenie adresy obsluhy INT 1ch.
        int 21h
        mov word ptr staryint,bx    ;Zistene hodnoty uschovaj.               
        mov word ptr staryint+2,es  ;Dolezite pre rezidentnu cast.
        mov ax,251ch                ;Sluzba DOSu pre nastavenie novej adresy
        mov dx,offset novyint       ;obsluzneho programu.
        int 21h
        mov ax,word ptr ds:[2ch]    ;Uvolni pamat prostredia.
        mov es,ax
        mov ah,49h
        int 21h
        mov dx,(start-zaciatok)/16+16+1
        mov ax,3100h                ;Sluzba DOSu pre ukoncenie programu a 
        int 21h                     ;ponechanie rezidentnej casti v RAM
                                    ;o dlzke ulozenej v registri DX.

address proc near
        mov ax,0                ;Vypocet adresy vo videoram (riadok).
        mov bx,0               ;Stlpec.
        mov dl,80
        mul dl
        add ax,bx
        mov dx,2
        mul dx  
        mov word ptr [offadr2],ax
        ret
address endp


help1:
          call address           ;Vypocitaj adresu vo videoram.
          mov ah,atributnavod    ;Farba.
          mov bx,segadr          ;Segment adresy vo videoram.
          mov es,bx
          mov bx,offadr2         ;Offset adresy vo videoram.
          xor si,si              ;Nastavenie na zaciatok retazca.
c_znak:
          mov al,navod[si]
          mov word ptr es:[bx],ax
          inc bx
          inc bx
          inc si
          cmp si,2000
          jl c_znak
          push si

          mov ah,01             ;Vypne kurzor na obrazovke.
          xor si,si
          mov ch,[si+2000h]
          mov cl,[si+2000h]
          int 10h

          mov ax,00              ;Cakaj na stlacenie lubovolnej klavesy.
          int 16h

          mov ah,01              ;Zapne kurzor na obrazovke.
          xor si,si
          mov ch,[si+0607h]
          mov cl,[si+0607h]
          int 10h

          mov ah,atributnavod    ;Farba.
          mov bx,segadr          ;Segment adresy vo videoram.
          mov es,bx
          mov bx,offadr2         ;Offset adresy vo videoram.
          xor si,si              ;Nastavenie na zaciatok retazca.
f_znak:
          mov al,' '
          mov word ptr es:[bx],ax
          inc bx
          inc bx
          inc si
          cmp si,2000
          jl f_znak

          mov ah,atributnavod    ;Farba.
          mov bx,segadr          ;Segment adresy vo videoram.
          mov es,bx
          mov bx,offadr2         ;Offset adresy vo videoram.
          pop si                 ;Nastavenie na zaciatok retazca.
e_znak:
          mov al,navod[si]
          mov word ptr es:[bx],ax
          inc bx
          inc bx
          inc si
          cmp si,3280
          jl e_znak

exit:	  mov ax,4c00h           ;Ukonci program navratom do DOSu.
          int 21h                ;Chybova uroven cislo 0.

msg0    db 'Clock version 1.21 - Nespravny parameter !!!',13,10,'$'
msg1    db 'Clock version 1.21 - Program nie je instalovany.',13,10,'$'
msg2    db 'Clock version 1.21 - Program nie je mozne uvolnit z pameti.',13,10,'$'
msg3    db 'Clock version 1.21 - Program je uvolneny z pameti.',13,10,'$'
msg4    db 'Clock version 1.21 - Skuste pouzit prikaz /? za suborom.','$'
msg5    db 'Clock version 1.21 - Program bol uz raz instalovany.','$'



zprava   db 13,10,13,10,13,10,13,10,'ͻ'
         db 13,10,'        Installed Resident CLOCK  (c) 1997         '
         db 13,10,'           Copyright  UNIVERSAL SYSTEMS            '
         db 13,10,'                                                   '
         db 13,10,'Ķ'
         db 13,10,'          PROGRAM   BY   Peter Gasparovic          '
         db 13,10,'Ķ'
         db 13,10,'                                                   '
         db 13,10,'                 Made in Slovakia                  '
         db 13,10,'ͼ',13,10,'$'

navod    db 'ͻ'
         db '                                                                              '
         db '                                  H  E  L  P                                  '
         db '                                                                '
         db '                                                                              '
         db ' Program CLOCK je rezidentny program, ktory vam umozni na obrazovke sledovat  '
         db ' aktualny datum a cas. Program bol napisany v jazyku assembler, z toho dovo-  '
         db ' du je i celkovy kod kratsi ako podobne programy v jazykoch C a Pascal.       '
         db '                                                                              '
         db '                                                                              '
         db ' Pouzivanie programu:                                                         '
         db '                                                          '
         db '                                                                            '
         db '  hodiny.com /? /h -> zobrazi sa help                                       '
         db '                                                                            '
         db '  hodiny.com /i -> prebehne instalacia programu                NIVERSAL     '
         db '                                                                  '
         db '  hodiny.com /o -> odinstalovanie programu                                   '
         db '                                                                  Ŀ      '
         db '  hodiny.com /d[+/-] -> [zapne/vypne] zobrazovanie datumu              YSTEMS'
         db '                                                                        '
         db '                                                                              '
         db '͹'
         db '     Autor programu:        P e t e r   G a s p a r o v i c                   '
         db 'ͼ'
         db '                                                                                '
         db '                                                                                '
         db ''
         db 'Programme CLOCK version 1.21    -    Copyright (c) 1997   -   UNIVERSAL SYSTEMS.'
         db ''
         db '         ADDRESSĿ                                                         '
         db '                                                                             '
         db '                                                                             '
         db '                     Ŀ                                   '
         db '                      UNIVERSAL  SYSTEMS                       NIVERSAL     '
         db '                       Peter Gasparovic                           '
         db '                        Ul. Zajacia 23                                       '
         db '                       919 04 SMOLENICE                           Ŀ      '
         db '                                                   YSTEMS'
         db '                                                                          '
         db ''




CODE    ENDS                    ;Koniec CODE segmentu.
        end start1              ;Totalny koniec programu.
