TIMEOUT     = 2184                 ;2 minutes

Model Tiny
CodeSeg
Org 100h

Start:      jmp Main

Counter     dw TIMEOUT
text        db "Screen saver has been installed.$"

NewInt08    proc           ;Timer interrupt

            cmp [cs:Counter],0     ;Counter already zero?
            je I08_done            ;Jump if yes

            dec [cs:Counter]       ;Decrement counter
            jnz I08_done           ;if nonzero, do nothing

            push ax dx             ;Save AX, DX
            mov dx,03C4h           ;Sequencer port
            mov al,1               ;Send command to
            out dx,al              ;turn off screen
            inc dx
            in al,dx
            or al,020h
            out dx,al
            pop dx ax              ;Restore DX, AX

I08_done:   db 0EAh                ;JMP FAR opcode

OldInt08    dw 0,0                 ;Old interrupt address

NewInt08    endp

NewInt09    proc              ;Keyboard interrupt

            cmp [cs:Counter],0     ;If Counter is nonzero,
            jne I09_done           ;screen is not blanked

            push ax dx             ;Save AX, DX
            mov dx,03C4h           ;Sequencer port
            mov al,1               ;Send command to
            out dx,al              ;turn on screen
            inc dx
            in al,dx
            and al,0DFh
            out dx,al
            pop dx ax              ;Restore DX, AX

I09_done:   mov [cs:Counter],TIMEOUT   ;Reset counter

            db 0EAh                ;JMP FAR opcode

OldInt09    dw 0,0                 ;Old interrupt address

NewInt09    endp

Main        proc

            mov ax,word ptr ds:[2ch]
            mov es,ax
            mov ah,49h             ;Free memory
            int 21h                ;DOS interrupt

            mov ax,3508h           ;Get interrupt vectors
            int 21h                ;and store them for the
            mov [OldInt08],bx      ;JMP instructions
            mov [OldInt08+2],es
            mov al,09h
            int 21h
            mov [OldInt09],bx
            mov [OldInt09+2],es

            mov ax,2508h           ;Set interrupt vectors
            mov dx,offset NewInt08
            int 21h
            mov al,09h
            mov dx,offset NewInt09
            int 21h

            mov ah,09h
            mov dx,offset text
            int 21h

            mov dx,offset Main     ;DX = last byte to keep
            int 27h                ;DOS TSR service

 Main       endp

End Start
