;VTREEH - Charles Petzold, 1985
CSEG Segment
Assume  CS:CSEG, DS:CSEG, ES:CSEG, SS:CSEG

 	Org     005Ch
FCB   	Label   Byte

       	Org     0080h
DefaultDTA    	Label   Byte

	Org     0100h
Entry: 	Jmp     Begin

SearchAsciiz 	db  ?,":\*.*",0
           	db  '(C) Copyright Charles '
	db 'Petzold, 1985'
DriveError: 	db  'Invalid disk drive$'
DosVersError 	db 'Requires DOS 2.0 +$'
FirstOrNext    	db  0
LevelsIn       	dw  0
SearchString 	db  "\*.*",0
SearchPointer 	dw  3 + Offset SearchAsciiz
DtaPointer     	dw  Offset EndProg
DashCount    	dw  ?
HiddenMark    	db  42

Begin: 	Cmp     AL,0FFh
            	Jnz     DriveSpecOK
            	Lea     DX,DriveError
ErrorExit: 	Mov     AH,9
               	Int     21h
 	Int     20h

DriveSpecOK:  	Mov     AH,30h
              	Int     21h
       	Cmp     AL,2
        	Jae     DosVersOK
	Lea     DX,DosVersError
 	Jmp     ErrorExit

DosVersOK:  	Mov     AL,[FCB]
               	Or      AL,AL
                	Jnz     NotDefault
               	Mov     AH,19h
               	Int     21h
 	Inc     AL
	
NotDefault: 	Mov     DL,AL
              	Add     AL,'@'
              	Mov     [SearchAsciiz],AL
              	Cld

MainLoop: 	Mov     DX,[DTAPointer]
               	Mov     AH,1Ah
               	Int     21h
	Mov     BX,[LevelsIn]
 	Add     BX,BX
  	Cmp     [FirstOrNext],0
    	Jnz     FindNextFile
	Mov Word Ptr [SubDirCounter+BX],0
	Mov DX,Offset SearchAsciiZ
 	Mov     CX,12h
	Mov     AH,4Eh
 	Int     21h
	Jmp     Short TestMatch

FindNextFile:  	Mov     AH,4Fh
               	Int     21h
TestMatch: 	Jnc     TestAttr
              	Jmp     NoMoreFiles
TestAttr:	Mov SI,[DTAPointer]
             	Cmp Byte Ptr [SI + 21],10h
             	Jz      FoundDirEntry
             	Cmp Byte Ptr [SI + 21],12h
              	Jnz     FindNextFile

FoundDirEntry: 	Add     SI,30
             	Cmp     Byte Ptr [SI],'.'
             	Jz      FindNextFile

 	Inc Word Ptr [SubDirCounter + BX]
  	Mov     CX,[LevelsIn]
   	Jcxz    LookAheadSearch
	Cmp Word Ptr [SubDirCounter + BX],1
 	Jz      NoSpaceIn
	Sub     BX,BX
IndentLoop:  	Mov     AL,179
             	Test  Word Ptr [SubDirCounter + BX],8000h
              	Jz      GotContinueChar
	Mov     AL,' '
GotContinueChar: 	Call    PrintChar
	Push    CX
	Mov     CX,16
BlankLoop: 	Mov     AL,' '
               	Call    PrintChar
	Loop    BlankLoop
	Pop     CX
	Inc     BX
 	Inc     BX
	Loop    IndentLoop

NoSpaceIn: 	Cmp  Word Ptr [SubDirCounter + BX],1
	Jnz     LookAheadSearch
	Mov     CX,[DashCount]
DashPrint:  	Mov     AL,196
              	Call    PrintChar
               	Loop    DashPrint

LookAheadSearch: 	Push    SI
	Mov     SI,[DtaPointer]
 	Mov     DI,Offset DefaultDTA
  	Mov     DX,DI
   	Mov     CX,43
    	Rep     Movsb
	Pop     SI
	Mov     AH,1Ah
 	Int     21h

CheckIfAnyMore:	Mov     AH,4Fh
              	Int     21h
               	Jc      CantFindAnother
	Cmp     Byte Ptr [DefaultDTA + 21],10h
 	Jz      GotOne
	Cmp     Byte Ptr [DefaultDTA + 21],12h
 	Jnz     CheckIfAnyMore
GotOne: 	Mov     AL,194
               	Cmp     Word Ptr [SubDirCounter + BX],1
            	Jz      GotGoodChar
	Mov     AL,195
 	Jmp     Short GotGoodChar
	
CantFindAnother: 	Mov     AL,196
            	Cmp   Word Ptr [SubDirCounter + BX],1
             	Jz      GotGoodChar
	Mov     AL,192
 	Or   Word Ptr [SubDirCounter + BX],8000h

GotGoodChar:  	Call    PrintChar              
              	Mov     AL,196
              	Call    PrintChar
	Mov     AL,' '
 	Call    PrintChar
   	Mov     CX,13
    	Mov     DI,[SearchPointer]

PrintNameLoop: 	Lodsb
             	Or      AL,AL
              	Jz      EndOfName
	Stosb
 	Call    PrintChar
	Loop    PrintNameLoop

EndOfName:  	Mov     AL,' '
            	Mov     SI,[DTAPointer]
             	Cmp     Byte Ptr [SI + 21],12h
             	Jnz     NowPrint
             	Mov     AL,HiddenMark
NowPrint: 	Call    PrintChar
	Mov     [DashCount],CX

FixUpSearch: 	Mov     [SearchPointer],DI
              	Inc     [SearchPointer]
              	Mov     SI,Offset SearchString
              	Mov     CX,5
             	Rep     Movsb
	Inc     [LevelsIn]
 	Mov     [FirstOrNext],0
  	Add     [DtaPointer],43
   	Jmp     MainLoop

NoMoreFiles: 	Cmp     [LevelsIn],0
               	Jz      Terminate
	Test  Word Ptr [SubDirCounter + BX],7FFFh
 	Jnz     BackUpOneDir
	Mov     AL,13
 	Call    PrintChar
  	Mov     AL,10
   	Call    PrintChar
BackUpOneDir: 	Mov     DI,Offset SearchAsciiz
             	Mov     CX,70
             	Mov     AL,0
              	Repnz   Scasb
         	Dec     DI
          	Mov     CX,64
           	Mov     AL,'\'
            	Std
             	Repnz   Scasb
          	Repnz   Scasb
          	Inc     DI
           	Mov     [SearchPointer],DI
            	Inc     [SearchPointer]
             	Mov     SI,Offset SearchString
              	Mov     CX,5
            	Cld
            	Rep     Movsb
            	Dec     [LevelsIn]
            	Mov     [FirstOrNext],1
            	Sub     [DtaPointer],43
            	Jmp     MainLoop
Terminate: 	Int     20h

PrintChar: 	Push    DX
             	Mov     DL,AL
             	Mov     AH,2
             	Int     21h
             	Pop     DX
             	 Ret

SubDirCounter 	Label   Word
EndProg       	equ     64 + Offset SubDirCounter
CSEG         	EndS
               	End Entry

